<p-table
  [value]="users" 
  [loading]="false"
  [rows]="30" 
  [showCurrentPageReport]="true"
  [scrollable]="true" scrollHeight="flex"
  dataKey="id"
  >
  <ng-template pTemplate="caption">
    <button pButton pRipple label="New User" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
  </ng-template>

  <ng-template pTemplate="header">
    <tr>
      <th pSortableColumn="username">Username
        <p-sortIcon field="username"></p-sortIcon>
      </th>
      <th pSortableColumn="role">Role
        <p-sortIcon field="role"></p-sortIcon>
      </th>
      <th>Subscription Expires</th>
      <th>Actions</th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-user let-editing="editing" let-ri="rowIndex">
    <tr [pEditableRow]="user">
      <td>{{ user.username }}</td>
      <td>{{ user.role }}</td>
      <td>{{ user.subscriptionExpires }}</td>
      <td class="users-actions">
        <button *ngIf="!editing" pButton pRipple type="button" icon="pi pi-pencil" (click)="openEdit(user)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple icon="pi pi-trash" class="p-button-rounded p-button-danger p-button-text" (click)="deleteUser(user)"></button>
      </td>
    </tr>
  </ng-template>
</p-table>

<p-dialog [(visible)]="userDialog" [style]="{ width: '450px' }" [header]="actionMode + ' user'" [modal]="true" styleClass="p-fluid">
  <ng-template pTemplate="content">
      <div class="field">
          <label for="username">Username</label>
          <input type="text" pInputText id="username" [(ngModel)]="newUser.username" required autofocus />
          <small class="p-error" *ngIf="submitted && !newUser.username">Username is required.</small>
      </div>
      <div class="field">
        <label for="password">Password</label>
        <input type="password" pInputText id="password" [(ngModel)]="newUser.password" [required]="actionMode === actionModeEnum.ADD" autofocus />
        <small class="p-error" *ngIf="submitted && !newUser.password && actionMode === actionModeEnum.ADD">Password is required.</small>
      </div>
      <div class="field">
          <label for="role">Role</label>
          <p-dropdown [(ngModel)]="newUser.role" inputId="role" [options]="roles" appendTo="body">
          </p-dropdown>
      </div>
  </ng-template>

  <ng-template pTemplate="footer">
      <button pButton pRipple label="Cancel" icon="pi pi-times" class="p-button-text" (click)="hideDialog()"></button>
      <button pButton pRipple label="Save" icon="pi pi-check" class="p-button-text" (click)="saveUser()"></button>
  </ng-template>
</p-dialog>

<p-toast [breakpoints]="{'768px': {width: '90%'}}"></p-toast>
<p-confirmDialog [breakpoints]="{'768px': 'unset'}" [style]="{width: '50vw'}"></p-confirmDialog>
